*CMZ :          25/02/2001  17.09.49  by  Andrei Minaenko
*-- Author :    Andrei Minaenko   10/11/97
      subroutine user_evt1
      implicit none
      include 'hec_par.inc'
      include 'hec_geo.inc'
      include 'hec_adc.inc'
      include 'hec_ped.inc'
      include 'hec_cal.inc'
      include 'hec_cal_coef.inc'
      include 'hec_max.inc'
      include 'hec_datacard.inc'
      include 'hec_trig.inc'
      include 'hec_runh.inc'
      include 'hec_tdc.inc'
c      include 'monte_carlo.inc'
C===    Local variables
*KEEP,sv_hist_num.
      integer idhist
      common/sv_hist_num/idhist


*KEND.
      include 'hec_cub.inc'
c      include 'hec_dig_sys.inc'
      integer i_adc_max
      real bound
      common/save_i_adc_max/i_adc_max,bound
      logical first
      save first
      integer i_adc,icell_max(i_adc_dim),n_sample,j_evt
      real amp_max,amp_cut,amp_mu,val,tdc_raw_ns,tdc_corr,tmax
      real tmax_tdc_raw,tmax_tdc_corr
      save icell_max,j_evt,amp_cut
      parameter (n_sample=8)
      data j_evt/0/,amp_cut/50.0/,amp_mu/10.0/,first/.true./
C===
      if (first) then
       first=.false.
       if (i_part.eq.2) amp_cut=amp_mu			! for a muon
      endif
      if (.not.trig_physics) return
      if (.not.trig_wac_c) return
C===    Use first 50 GOOD events to find the most loaded cell
      if (j_evt.le.50) then
       if (j_evt.eq.0) call vzero(icell_max,i_adc_used)
       amp_max=0.0
       do i_adc=1,i_adc_used
        val=i_adc_ic_t(i_adc,n_sample)-adc_ped(i_adc)
        if (val.gt.amp_max) then
         amp_max=val
         i_adc_max=i_adc
        endif
       enddo
       if (amp_max.gt.amp_cut) then
        icell_max(i_adc_max)=icell_max(i_adc_max)+1
        j_evt=j_evt+1
       endif
       if (j_evt.eq.50) then
        amp_max=0.0
        do i_adc=1,i_adc_used
         if (icell_max(i_adc).gt.amp_max) then
          amp_max=icell_max(i_adc)
          i_adc_max=i_adc
         endif
        enddo
        print *,' The most loaded cell in run ',run_no,' is i_adc=',
     ,  i_adc_max,' : ',icell_max(i_adc_max),' max hits in 50 events'
        j_evt=51
       endif
       return
      endif		! j_evt.le.50
C===    Histogram filling
      amp_max=adc_cub_ic(i_adc_max,1)-adc_ped(i_adc_max)
C===    Take the events with a large signal in i_adc_max only
      if (amp_max.lt.amp_cut) return
      tmax=adc_cub_ic(i_adc_max,2)
      tdc_raw_ns=tdc_raw*tdc_raw_to_ns
      tdc_raw_ns=tdc_raw_ns/25.
C      tdc_corr=tdc_ns/25. - tdc_slice_shift
      tdc_corr=tdc_ns/25.
      tmax_tdc_raw =tmax+tdc_raw_ns
      tmax_tdc_corr=tmax+tdc_corr
      call hf1(idhist+1,float(tdc_raw),1.)
      call hf1(idhist+2,amp_max,1.)
      call hf1(idhist+3,tmax,1.)
      call hf1(idhist+4,tmax_tdc_raw,1.)
      call hf1(idhist+5,tmax_tdc_corr,1.)
      if (.not.tdc_dubious) call hf1(idhist+6,tmax_tdc_corr,1.)
      call hf2(idhist+7,tmax,tdc_raw_ns,1.)
      call hf2(idhist+8,tmax_tdc_raw,tmax,1.)
      call hf2(idhist+9,tmax_tdc_raw,tdc_raw_ns,1.)
      end			! user_evt1
